'###################################################
'Bitmaps und TrueType 
'###################################################
'Andreas Miethe + Februar 2002
'####################################################

DEF CreateCompatibleBitmap(3) ! "GDI32","CreateCompatibleBitmap"
DEF BeginPath(1) ! "GDI32","BeginPath"
DEF EndPath(1) ! "GDI32","EndPath"
DEF FillPath(1) ! "GDI32","FillPath"
DEF SetBkMode(2) ! "GDI32","SetBkMode"
DEF TextOut(5) ! "GDI32","TextOutA"
DEF SelectClipRgn(2) ! "GDI32","SelectClipRgn"
DEF DeleteObject(1) ! "GDI32","DeleteObject"
DEF SelectObject(2) ! "GDI32","SelectObject"
DEF PathToRegion(1) ! "GDI32","PathToRegion"
DEF CreateCompatibleDC(1) ! "GDI32","CreateCompatibleDC"
DEF DeleteDC(1) ! "GDI32","DeleteDC"
DEF Bitblt(9) ! "GDI32","BitBlt"
DEF LoadImage(6) ! "USER32","LoadImageA"
DEF CreatePatternBrush(1) ! "GDI32","CreatePatternBrush"
DEF CreateBrushIndirect(1) ! "GDI32","CreateBrushIndirect"
DEF PatBlt(6) ! "GDI32","PatBlt"
DEF TextOut(5) ! "GDI32","TextOutA"
DEF GetTextExtentPoint32(4) ! "GDI32","GetTextExtentPoint32A"

Proc DrawBitmapText
  Parameters Text$,x%,y%,Bild$,Stretch%
  Declare HBitmap&,HRgn&,CHDC&,Image&,PatBrush&,OldBrush&,Size#,TextW&,TextH&
  'Rechteck ermitteln
  Dim Size#,8
  GetTextExtentPoint32(%Hdc,ADDR(Text$),Len(Text$),Size#)
  TextW& = Long(Size#,0)
  TextH& = Long(Size#,4)
  Dispose Size#
  'Speicherbitmap anlegen
  HBitmap& = CreateCompatibleBitmap(%hdc,TextW&,TextH&)
  'SpeicherDCs anlegen
  CHDC& = CreateCompatibleDC(%hdc)
  'Speicherbitmap in SpeicherDC
  SelectObject(CHDC&,HBitmap&)
  'HDC in SpeicherDC kopieren
  Bitblt(CHDC&,0,0,TextW&,TextH&,%hdc,x%,y%,$0CC0020)
  'Bild laden und Brush erzeugen
  case Stretch% = 0 : Image& = LoadImage(0,ADDR(Bild$),0,0,0,$50)
  case Stretch% <> 0 : Image& = LoadImage(0,ADDR(Bild$),0,TextW&,TextH&,$50)
  PatBrush& = CreatePatternBrush(Image&)
  OldBrush& = SelectObject(CHDC&,PatBrush&)
  'Zeichenoperationen aufzeichnen
  BeginPath(%Hdc)
  SetBkMode(%Hdc,1)'transparent
  TextOut(%Hdc,0,0,ADDR(Text$),Len(Text$))
  EndPath(%Hdc)
  'Region anlegen, dadurch erhaelt man eine Maske in die gezeichnet wird
  HRgn& = PathToRegion(%Hdc)
  'Region selectieren
  SelectClipRgn(CHDC&,HRgn&)
  'Zeichenoperationen fuer selektierte Region
  PatBlt(CHDC&,0,0,TextW&,TextH&,$0F00021)
  'Region freigeben
  SelectClipRgn(CHDC&,0)
  'vom MemeoryDC ins HDC und HDC2
  Bitblt(%hdc,x%,y%,TextW&,TextH&,CHDC&,0,0,$0CC0020)
  Bitblt(%hdc2,x%,y%,TextW&,TextH&,CHDC&,0,0,$0CC0020)
  'Objekte freigeben
  DeleteObject(HRgn&)
  DeleteObject(HBitmap&)
  DeleteObject(Image&)
  DeleteObject(OldBrush&)
  DeleteObject(PatBrush&)
  DeleteDC(CHDC&)
EndProc

